#include "trimesh.h"
#include <algorithm>
#include <assert.h>
#include <cmath>
#include <iostream>
#include <float.h>
#include <string.h>
#include "../ui/TraceUI.h"
extern TraceUI *traceUI;
extern TraceUI *traceUI;

using namespace std;

Trimesh::~Trimesh() {
  for (auto f : faces)
    delete f;
}

// must add vertices, normals, and materials IN ORDER
void Trimesh::addVertex(const glm::dvec3 &v) { vertices.emplace_back(v); }

void Trimesh::addNormal(const glm::dvec3 &n) { normals.emplace_back(n); }

void Trimesh::addColor(const glm::dvec3 &c) { vertColors.emplace_back(c); }

void Trimesh::addUV(const glm::dvec2 &uv) { uvCoords.emplace_back(uv); }

// Returns false if the vertices a,b,c don't all exist
bool Trimesh::addFace(int a, int b, int c) {
  int vcnt = vertices.size();

  if (a >= vcnt || b >= vcnt || c >= vcnt)
    return false;

  TrimeshFace *newFace = new TrimeshFace(this, a, b, c);
  if (!newFace->degen)
    faces.push_back(newFace);
  else
    delete newFace;

  // Don't add faces to the scene's object list so we can cull by bounding
  // box
  return true;
}

// Check to make sure that if we have per-vertex materials or normals
// they are the right number.
const char *Trimesh::doubleCheck() {
  if (!vertColors.empty() && vertColors.size() != vertices.size())
    return "Bad Trimesh: Wrong number of vertex colors.";
  if (!uvCoords.empty() && uvCoords.size() != vertices.size())
    return "Bad Trimesh: Wrong number of UV coordinates.";
  if (!normals.empty() && normals.size() != vertices.size())
    return "Bad Trimesh: Wrong number of normals.";

  return 0;
}

bool Trimesh::intersectLocal(ray &r, isect &i) const {
  bool have_one = false;
  for (auto face : faces) {
    isect cur;
    if (face->intersectLocal(r, cur)) {
      if (!have_one || (cur.getT() < i.getT())) {
        i = cur;
        have_one = true;
      }
    }
  }
  if (!have_one)
    i.setT(1000.0);
  return have_one;
}

bool TrimeshFace::intersect(ray &r, isect &i) const {
  return intersectLocal(r, i);
}


// Intersect ray r with the triangle abc.  If it hits returns true,
// and put the parameter in t and the barycentric coordinates of the
// intersection in u (alpha) and v (beta).
bool TrimeshFace::intersectLocal(ray &r, isect &i) const {
  
  double t = -(glm::dot(this->normal, r.getPosition() - this->parent->vertices[this->ids[1]])) / (glm::dot(this->normal, r.getDirection()));
  if(t <= RAY_EPSILON) {
    return false;
  }
  glm::dvec3 Q = r.getPosition() + r.getDirection()*t;
  glm::dvec3 A = this->parent->vertices[this->ids[0]];
  glm::dvec3 B = this->parent->vertices[this->ids[1]];
  glm::dvec3 C = this->parent->vertices[this->ids[2]];

  double Aa = glm::length(glm::cross((C - B), (Q - B))) / 2;
  double Ab = glm::length(glm::cross((A - C), (Q - C))) / 2;
  double Ac = glm::length(glm::cross((B - A), (Q - A))) / 2;

  double area = glm::length(glm::cross((B - A), (C - A))) / 2;

  double alpha = Aa / area;
  double beta = Ab / area;
  double gamma = Ac / area;

  // Check if the intersection is in the triangle
  bool test1 = glm::dot(glm::cross((B - A), (Q - A)), this->normal) >= 0;
  bool test2 = glm::dot(glm::cross((C - B), (Q - B)), this->normal) >= 0;
  bool test3 = glm::dot(glm::cross((A - C), (Q - C)), this->normal) >= 0;
  if (!test1 || !test2|| !test3) {
    return false;
  }

  i.setBary(alpha, beta, gamma);
  i.setUVCoordinates(glm::dvec2(alpha, beta));
  i.setT(t);

  // re-calculate normals
  glm::dvec3 new_normal = this->normal;

  if(this->parent->normals.size() > 0) {
    new_normal = this->parent->normals[this->ids[0]] * alpha + this->parent->normals[this->ids[1]] * beta + this->parent->normals[this->ids[2]] * gamma;
    new_normal = glm::normalize(new_normal);
  }
  i.setN(new_normal);
  // Vertex UV
  if (this->parent->uvCoords.size() > 0) {
    glm::dvec2 new_uv = this->parent->uvCoords[this->ids[0]] * alpha + this->parent->uvCoords[this->ids[1]] * beta + this->parent->uvCoords[this->ids[2]] * gamma;
    i.setUVCoordinates(new_uv);
  }
  // Vertex Color
  else if (this->parent->vertColors.size() > 0) {
    Material new_mat(this->parent->material);
    glm::dvec3 new_color = this->parent->vertColors[this->ids[0]] * alpha + this->parent->vertColors[this->ids[1]] * beta + this->parent->vertColors[this->ids[2]] * gamma;
    new_mat.setDiffuse(new_color);
    i.setMaterial(new_mat);
  }
  // Uniform Color
  else {
    i.setMaterial(this->parent->material);
  }
  i.setObject(this->parent);
  return true;
}

// Once all the verts and faces are loaded, per vertex normals can be
// generated by averaging the normals of the neighboring faces.
void Trimesh::generateNormals() {
  int cnt = vertices.size();
  normals.resize(cnt);
  std::vector<int> numFaces(cnt, 0);

  for (auto face : faces) {
    glm::dvec3 faceNormal = face->getNormal();

    for (int i = 0; i < 3; ++i) {
      normals[(*face)[i]] += faceNormal;
      ++numFaces[(*face)[i]];
    }
  }

  for (int i = 0; i < cnt; ++i) {
    if (numFaces[i])
      normals[i] /= numFaces[i];
  }

  vertNorms = true;
}

